﻿using Connection.Class;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using WBP_Office.Class;

namespace WBP_Office_API_Demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            System.Reflection.Assembly assembly = System.Reflection.Assembly.GetExecutingAssembly();
            var WBP_OfficeInfo = System.Reflection.Assembly.GetAssembly(typeof(WBP_Office.WBP_Office)).GetName();
            this.Text = $"{assembly.GetName().Name}  v{assembly.GetName().Version.ToString()}           {WBP_OfficeInfo.Name}  v{WBP_OfficeInfo.Version}";
            this.comboBox4.SelectedIndex = 1;
            this.comboBox5.SelectedIndex = 0;
            this.comboBox6.SelectedIndex = 1;
            this.comboBox7.SelectedIndex = 1;
            this.comboBox8.SelectedIndex = 1;
            this.comboBox9.SelectedIndex = 0;
            this.comboBox10.SelectedIndex = 1;

            this.comboBox11.SelectedIndex = 1;
            this.comboBox12.SelectedIndex = 1;
            this.comboBox13.SelectedIndex = 0;
            this.comboBox14.SelectedIndex = 1;
            this.comboBox15.SelectedIndex = 1;
            this.comboBox16.SelectedIndex = 0;
            this.comboBox17.SelectedIndex = 0;
            this.comboBox18.SelectedIndex = 1;
            this.comboBox19.SelectedIndex = 0;
            this.comboBox20.SelectedIndex = 0;
        }
        Form_Chart form_Chart = new Form_Chart();
        static WBP_Office.WBP_Office office;
        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox1.SelectedIndex = 0;
            comboBox3.SelectedIndex = 1;
        }

        private void Office_OnReceived(Command command)
        {
            switch (command.CMD)
            {
                case (byte)WBP_Office.Enum.Command.StartRemoteMeasurement:
                    this.richTextBox1.BeginInvoke((MethodInvoker)delegate
                    {
                        richTextBox1.Focus();
                        richTextBox1.AppendText(Environment.NewLine);
                        richTextBox1.AppendText("Start Remote Measurement,DataFormat is " + ((WBP_Office.Enum.DataFormat)command.Data).ToString());
                    });
                    break;
                case (byte)WBP_Office.Enum.Command.StopRemoteMeasurement:
                    this.richTextBox1.BeginInvoke((MethodInvoker)delegate
                    {
                        richTextBox1.AppendText(Environment.NewLine);
                        richTextBox1.AppendText("Stop Remote Measurement");
                    });
                    break;
                case (byte)WBP_Office.Enum.Command.RemoteStatus:
                    this.richTextBox1.BeginInvoke((MethodInvoker)delegate
                    {
                        richTextBox1.AppendText(Environment.NewLine);
                        richTextBox1.AppendText("call back RemoteStatus");
                        PrintAllProperties((Remote_Measurement_Status)command.Data, true);
                    });
                    break;
                case (byte)WBP_Office.Enum.Command.MeasurementResults:
                    this.richTextBox1.BeginInvoke((MethodInvoker)delegate
                    {
                        richTextBox1.AppendText(Environment.NewLine);
                        richTextBox1.AppendText("call back MeasurementResults");
                        PrintAllProperties((MData_Measurement)command.Data, true);
                    });
                    break;
                case (byte)WBP_Office.Enum.Command.dataRead:
                    this.richTextBox1.BeginInvoke((MethodInvoker)delegate
                    {
                        Data data = (Data)command.Data;
                        PrintAllProperties(data, true);
                        form_Chart.chart1.Series[0].Points.Clear();
                        form_Chart.chart2.Series[0].Points.Clear();
                        form_Chart.chart1.Series[0].Points.DataBindY(data.CBPData);
                        form_Chart.chart2.Series[0].Points.DataBindY(data.CalCBP);
                    });
                    break;
            }
        }

        private void Office_OnDisConnected()
        {
            try
            {
                this.Label_DevicePath.Invoke((MethodInvoker)delegate
                {
                    this.Label_DevicePath.Text = "";
                });
                this.button_Send.Invoke((MethodInvoker)delegate
                {
                    button_Send.Enabled = false;
                });
            }
            catch { }
        }
        private void Office_OnConnected()
        {
            this.Label_DevicePath.Invoke((MethodInvoker)delegate
            {
                try
                {
                    this.Label_DevicePath.Text = office.DevicePath;
                }
                catch { }
            });
            this.button_Send.Invoke((MethodInvoker)delegate
            {
                button_Send.Enabled = true;
            });
        }

        private void button_Send_Click(object sender, EventArgs e)
        {
            Command callback;
            StringBuilder sb = new StringBuilder();
            switch (comboBox1.SelectedIndex)
            {
                case 0:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.dataReadAll());
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    comboBox2.Items.Clear();
                    List<MData> listMData = (List<MData>)callback.Data;
                    listMData.Where(x => x.Condition == 1).ToList().ForEach(x => comboBox2.Items.Add(x.Index));
                    try
                    {
                        comboBox2.SelectedIndex = 0;
                    }
                    catch { }
                    PrintAllProperties(listMData);
                    listMData.ForEach(x => PrintAllProperties(x, true));
                    break;
                case 1:
                    if (comboBox2.SelectedIndex == -1)
                    {
                        richTextBox1.Text = "Choose an ID";
                        return;
                    }
                    richTextBox1.Clear();
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.dataRead((int)comboBox2.SelectedItem, (WBP_Office.Enum.DataFormat)(comboBox3.SelectedIndex == 2 ? 3 : comboBox3.SelectedIndex)));
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    /*
                     *Because Office_OnReceived has print, is is not need here.
                    Data data = (Data)callback.Data;
                    PrintAllProperties(data);
                    */
                    break;
                case 2:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.dataClear());
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    richTextBox1.Text = "Memory have clear!";
                    break;
                case 3:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.userInfoRead());
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    UserInfo userInfo = (UserInfo)callback.Data;
                    sb.AppendLine(String.Format("UserID:{0}", userInfo.UserID));
                    textBox_NewID.Text = userInfo.UserID;
                    sb.AppendLine(String.Format("Protocal ID:{0}", userInfo.ProtocolID));
                    sb.AppendLine(String.Format("Max memory:{0}", userInfo.MaxMemory));
                    sb.AppendLine(String.Format("IHB:{0}", userInfo.IHB));
                    sb.AppendLine(String.Format("Firmware version:{0}", userInfo.FMVersion));
                    sb.AppendLine(String.Format("Firmware Date", userInfo.FMDate.ToString("yyyy-MM-dd")));
                    sb.AppendLine(String.Format("CBP:{0}", userInfo.CBP));
                    sb.AppendLine(String.Format("Voltage:{0} V", userInfo.BatteryVoltage));
                    sb.AppendLine(String.Format("arrhythmiaDisplay:{0}", userInfo.arrhythmiaDisplay.ToString()));
                    sb.AppendLine(String.Format("AFIB:{0}", userInfo.Afib));
                    richTextBox1.Text = sb.ToString();
                    break;
                case 4:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.userIDWrite(textBox_NewID.Text));
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    if (callback.CMD == (byte)WBP_Office.Enum.Command.userIDWrite)
                        richTextBox1.Text = "New ID have writed";
                    break;
                case 5:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.settingRead_BPM());
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    Setting_BPM setting_BPM = (Setting_BPM)callback.Data;
                    textBox1.Text = setting_BPM.HI_infPressure.ToString();
                    textBox2.Text = setting_BPM.AUS_HI_infPressure.ToString();
                    textBox3.Text = setting_BPM.IntervalTime.ToString();
                    textBox4.Text = setting_BPM.AutoMeasureNumber.ToString();
                    textBox5.Text = setting_BPM.RestTime.ToString();
                    comboBox4.SelectedItem = setting_BPM.SW_AFib.ToString();
                    comboBox5.SelectedItem = setting_BPM.SW_AMPM.ToString();
                    comboBox6.SelectedItem = setting_BPM.SW_AUS_Hide.ToString();
                    comboBox7.SelectedItem = setting_BPM.SW_AUTO_hide.ToString();
                    comboBox8.SelectedItem = setting_BPM.SW_CBP.ToString();
                    comboBox9.SelectedItem = setting_BPM.SW_Kpa.ToString();
                    comboBox10.SelectedItem = setting_BPM.SW_SEL_silent.ToString();
                    comboBox19.SelectedItem = setting_BPM.SW_AVG_no_include_first.ToString();
                    PrintAllProperties(setting_BPM);
                    break;
                case 6:
                    if (String.IsNullOrEmpty(textBox1.Text) || String.IsNullOrEmpty(textBox2.Text) || String.IsNullOrEmpty(textBox3.Text) || String.IsNullOrEmpty(textBox4.Text) || String.IsNullOrEmpty(textBox5.Text))
                    {
                        richTextBox1.Text = "Please fill Setting_BPM column";
                        break;
                    }
                    Setting_BPM Newsetting_BPM = new Setting_BPM
                    {
                        HI_infPressure = int.Parse(textBox1.Text),
                        AUS_HI_infPressure = int.Parse(textBox2.Text),
                        IntervalTime = int.Parse(textBox3.Text),
                        AutoMeasureNumber = int.Parse(textBox4.Text),
                        RestTime = int.Parse(textBox5.Text),
                        SW_AFib = bool.Parse(comboBox4.SelectedItem.ToString()),
                        SW_AMPM = (WBP_Office.Enum.AMPM)Enum.Parse(typeof(WBP_Office.Enum.AMPM), comboBox5.SelectedItem.ToString()),
                        SW_AUS_Hide = bool.Parse(comboBox6.SelectedItem.ToString()),
                        SW_AUTO_hide = bool.Parse(comboBox7.SelectedItem.ToString()),
                        SW_CBP = bool.Parse(comboBox8.SelectedItem.ToString()),
                        SW_Kpa = (WBP_Office.Enum.PressureUnit)Enum.Parse(typeof(WBP_Office.Enum.PressureUnit), comboBox9.SelectedItem.ToString()),
                        SW_SEL_silent = bool.Parse(comboBox10.SelectedItem.ToString()),
                        SW_AVG_no_include_first = bool.Parse(comboBox19.SelectedItem.ToString())
                    };
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.settingWrite_BPM(Newsetting_BPM));
                    if (callback == null)
                        richTextBox1.Text = "No call back,Please try again";
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.settingWrite_BPM)
                        richTextBox1.Text = "Write Success!";
                    break;
                case 7:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.deviceIDRead());
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    DeviceID_and_Info deviceID_And_Info = (DeviceID_and_Info)callback.Data;
                    textBox_DeviceID.Text = deviceID_And_Info.ID;
                    comboBox20.SelectedIndex = deviceID_And_Info.ConnectType == WBP_Office.Enum.ConnectType.USBOnly ? 0 : 1;
                    PrintAllProperties(deviceID_And_Info);
                    break;
                case 8:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.timeRead());
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    DateTime dateTime = (DateTime)callback.Data;
                    dateTimePicker1.Value = new DateTime(Math.Max(dateTime.Ticks, new DateTime(1753, 1, 1).Ticks));
                    richTextBox1.Text = "";
                    if (dateTime.Ticks < new DateTime(1753, 1, 1).Ticks)
                        richTextBox1.AppendText("Datetimepicker can't be set to before 1753/1/1 value,so show 1753/1/1" + Environment.NewLine);
                    richTextBox1.AppendText(dateTime.ToString("yyyy-MM-dd HH:mm:ss"));
                    break;
                case 9:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.timeWrite(dateTimePicker1.Value));
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    if (callback.CMD == (byte)WBP_Office.Enum.Command.timeWrite)
                        richTextBox1.Text = "Time had been sync";
                    break;
                case 10:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.settingRead_BPM_Function());
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    Setting_BPM_Function setting_BPM_Function = (Setting_BPM_Function)callback.Data;
                    comboBox11.SelectedItem = setting_BPM_Function.Fun_SEL_AFib.ToString();
                    comboBox12.SelectedItem = setting_BPM_Function.Fun_SEL_AMPM.ToString();
                    comboBox13.SelectedItem = setting_BPM_Function.Fun_SEL_AutoTest.ToString();
                    comboBox14.SelectedItem = setting_BPM_Function.Fun_SEL_Bluetooth.ToString();
                    comboBox15.SelectedItem = setting_BPM_Function.Fun_SEL_CBP_algo.ToString();
                    comboBox16.SelectedItem = setting_BPM_Function.Fun_SEL_CBP_CL.ToString();
                    comboBox17.SelectedItem = setting_BPM_Function.Fun_SEL_RS232.ToString();
                    comboBox18.SelectedItem = setting_BPM_Function.Fun_SEL_UnitKpa.ToString();
                    PrintAllProperties(setting_BPM_Function);
                    break;
                case 11:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.bluetoothnameRead());
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    string s = (string)callback.Data;
                    textBox_BTName.Text = s;
                    richTextBox1.Text = s;
                    break;
                case 12:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.StartRemoteMeasurement((WBP_Office.Enum.DataFormat)(comboBox3.SelectedIndex == 2 ? 3 : comboBox3.SelectedIndex)));
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    break;
                case 13:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.StopRemoteMeasurement());
                    if (callback == null)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    break;
                case 14:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.devicDecrypt(textBox6.Text));
                    if (callback == null)
                    {

                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    else if (callback.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    if (callback.CMD == (byte)WBP_Office.Enum.Command.deviceDecrypt)
                    {
                        richTextBox1.Text = "Had decrypt " +
                        ((WBP_Office.Enum.Decrypt)callback.Data).ToString();
                    }
                    break;
            }
        }


        private void PrintAllProperties(object obj, bool append = false)
        {
            StringBuilder sb = new StringBuilder();
            foreach (PropertyDescriptor descriptor in TypeDescriptor.GetProperties(obj))
            {
                string name = descriptor.Name;
                object value = descriptor.GetValue(obj);

                dynamic vars = value as List<int>;
                bool printed = false;
                int index = 0;
                if (vars != null)
                {
                    sb.AppendFormat("{0}:", name);
                    ((List<int>)value).ToList().ForEach(x => sb.AppendFormat("{0}{1}", index++ == 0 ? "" : ",", x));
                    printed = true;
                }
                vars = value as List<string>;
                if (vars != null)
                {
                    sb.AppendFormat("{0}:{1}", name, string.Join(",", (List<string>)value));
                    printed = true;
                }
                vars = value as int[];
                if (vars != null)
                {
                    sb.AppendFormat("{0}:", name);
                    ((int[])value).ToList().ForEach(x => sb.AppendFormat("{0}{1}", index++ == 0 ? "" : ",", x));
                    printed = true;
                }
                if (!printed)
                    sb.AppendLine(String.Format("{0}:{1}", name, value));
                else
                    sb.AppendLine();
            }
            if (!append)
                richTextBox1.Clear();
            if (richTextBox1.Text.Length != 0)
                richTextBox1.AppendText(Environment.NewLine);
            richTextBox1.AppendText(sb.ToString());
        }
        private void button1_Click(object sender, EventArgs e)
        {

            form_Chart.Show();
        }

        private void DeviceIDCheck(object sender, KeyPressEventArgs e)
        {
            try
            {
                if (e.KeyChar != '\b')
                    Convert.ToInt32(e.KeyChar.ToString(), 16);
            }
            catch { e.Handled = true; }
        }

        private async void Button_BLE_Click(object sender, EventArgs e)
        {
            if (!Connection.GlobalFunction.WinRT_API_Support)
            {
                MessageBox.Show("Operating system requires Windows 10 1803 or higher!");
                return;
            }
            Form_BLE_Discover form_BLE_Discover = new Form_BLE_Discover();
            form_BLE_Discover.ShowDialog();
            switch (form_BLE_Discover.BLEAction)
            {
                case BLEAction.Connect:
                    office?.HID_Disconnect();
                    office = new WBP_Office.WBP_Office(textBox_key.Text, true);
                    office.OnDisConnected += Office_OnDisConnected;
                    office.OnReceived += Office_OnReceived;
                    var connectionResult = await office.ConnectWithBLE(form_BLE_Discover.BLE_ID);
                    if (connectionResult.ErrorMessage == "Device is unreachable (i.e. out of range or shutoff)")
                    {
                        MessageBox.Show("Please check the connection or unpair BLE, both of PC and blood pressure monitor.");
                        Office_OnDisConnected();
                    }
                    if (office.Connected)
                    {
                        var result = await Connection.PairingHelper.PairDeviceAsync(form_BLE_Discover.BLE_ID);
                        try
                        {
                            await office.SendMessageAsync(WBP_Office.SendMessage.ToCommand.timeRead());
                        }
                        catch
                        {
                            MessageBox.Show("Please unpair BLE on blood pressure monitor.");
                            await Connection.PairingHelper.UnpairDeviceAsync(form_BLE_Discover.BLE_ID);
                            await office?.DisconnectWithBLE();
                        }
                        ThreadStart threadStart = new ThreadStart(() => Office_OnConnected());
                        Thread thread = new Thread(threadStart);
                        thread.Start();
                    }
                    break;
                case BLEAction.Disconnect:
                    if (office.ConnectionType == 1)
                    {
                        office?.Dispose();
                        office = new WBP_Office.WBP_Office(textBox_key.Text);
                        office.OnConnected += Office_OnConnected;
                        office.OnDisConnected += Office_OnDisConnected;
                    }
                    break;
                case BLEAction.Pair:
                    await Connection.PairingHelper.PairDeviceAsync(form_BLE_Discover.BLE_ID);
                    break;
                case BLEAction.Unpair:
                    await Connection.PairingHelper.UnpairDeviceAsync(form_BLE_Discover.BLE_ID);
                    break;
            }
        }
        private void Button_CheckKey_Click(object sender, EventArgs e)
        {
            try
            {
                office = new WBP_Office.WBP_Office(textBox_key.Text);
                office.OnConnected += Office_OnConnected;
                office.OnDisConnected += Office_OnDisConnected;
                office.OnReceived += Office_OnReceived;
                Office_OnConnected();
                button_BLE.Enabled = true;
                button_Send.Enabled = true;
                textBox_key.Enabled = false;
                (sender as Button).Enabled = false;
            }
            catch (Exception ee)
            {
                if (ee.Message == "Key Fail!")
                {
                    MessageBox.Show("Key Fail!");
                }
            }
        }
    }
}
